<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolPodlaKategorieVozidla;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use Illuminate\Support\Str;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\EChartSourceItemContract;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\KategoriaVozidlaChartEnum;

/**
 * Class PocetKontrolPodlaKategorieVozidlaEChartSourceItem
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Pracovisko\PocetKontrolPodlaKategorieVozidla
 */
final class PocetKontrolPodlaKategorieVozidlaEChartSourceItem implements EChartSourceItemContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var int
     */
    protected int $pocet = 0;
    /**
     * @var \Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\KategoriaVozidlaChartEnum
     */
    private KategoriaVozidlaChartEnum $kategoriaVozidla;

    /**
     * @param string $kategoria
     */
    public function __construct(string $kategoria)
    {
        $this->kategoriaVozidla = $this->kategoriaVozidlaChartEnum($kategoria);
    }

    /**
     * @param string $kategoriaVozidla
     *
     * @return \Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\KategoriaVozidlaChartEnum
     */
    private function kategoriaVozidlaChartEnum(string $kategoriaVozidla): KategoriaVozidlaChartEnum
    {
        switch ($kategoriaVozidla) {
            case Str::startsWith($kategoriaVozidla, ['M1', 'N1']):
                $kat = KategoriaVozidlaChartEnum::M1_N1;
                break;
            case Str::startsWith($kategoriaVozidla, ['M2', 'M3']):
                $kat = KategoriaVozidlaChartEnum::M2_M3;
                break;
            case Str::startsWith($kategoriaVozidla, ['N2', 'N3']):
                $kat = KategoriaVozidlaChartEnum::N2_N3;
                break;
            default:
                $kat = KategoriaVozidlaChartEnum::T;
                break;
        }

        return $kat;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla): self
    {
        $kat = $this->kategoriaVozidlaChartEnum($pocetKontrolPodlaKategorieVozidla->kategoria());

        if (!$this->kategoriaVozidla->equal($kat)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa kategoria vozidla %s, vstupny atribut obsahuje kategoriu vozidla %s',
                $this->kategoriaVozidla->label(),
                $pocetKontrolPodlaKategorieVozidla->kategoria()
            ));
        }

        $this->pocet += $pocetKontrolPodlaKategorieVozidla->pocet();

        return $this;
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\KategoriaVozidlaChartEnum $kategoriaVozidlaChartEnum
     * @param int                                                                                                        $pocet
     *
     * @return void
     */
    public function incrementData(KategoriaVozidlaChartEnum $kategoriaVozidlaChartEnum, int $pocet)
    {
        if (!$this->kategoriaVozidla->equal($kategoriaVozidlaChartEnum)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa kategoria vozidla %s, vstupny atribut obsahuje kategoriu vozidla %s',
                $this->kategoriaVozidla->label(),
                $kategoriaVozidlaChartEnum->label()
            ));
        }

        $this->pocet += $pocet;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\KategoriaVozidlaChartEnum
     */
    public function kategoriaVozidla(): KategoriaVozidlaChartEnum
    {
        return $this->kategoriaVozidla;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => $this->kategoriaVozidla->label(),
            'kategoria' => $this->kategoriaVozidla->value,
            'pocet' => $this->pocet,
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
